use crate::error::CustomError;

use super::registry::Registry;
use super::IElement;

#[derive(Debug)]
pub(crate) struct IQuoteBlock {
    pub(crate) children: Vec<IElement>,
}

impl IQuoteBlock {
    pub(crate) async fn new<'parse>(
        registry: &mut Registry<'parse>,
        original: &organic::types::QuoteBlock<'parse>,
    ) -> Result<IQuoteBlock, CustomError> {
        let children = {
            let mut ret = Vec::new();
            for obj in original.children.iter() {
                ret.push(IElement::new(registry, obj).await?);
            }
            ret
        };

        Ok(IQuoteBlock { children })
    }
}
